#include "NButton.h"
#include <iostream>

#define NUM 100

NButton::NButton()
:   m_Table(80, 50, false),
    m_Scrolled()
{
    set_title("Gtk::Table");

    //add(m_Scrolled);
    //m_Scrolled.add(m_Table);
    add(m_Table);

    int time, start, end;
    start = clock();

    for (int x = 0; x<80 ; x++)
    {
        for (int y = 0; y<10; y++)
        {
            Gtk::Button * b = manage(new Gtk::Button(std::string("t")));

            // Now when the button is clicked, we call the "on_button_clicked" function
            // with a pointer to "button 1" as it's argument
            b->signal_clicked().connect( sigc::mem_fun(*this, &NButton::on_button_numbered));

            // instead of gtk_container_add, we pack this button into the invisible
            // box, which has been packed into the window.
            // note that the pack_start default arguments are Gtk::EXPAND | Gtk::FILL, 0
            m_Table.attach(*b, x, x+1, y, y+1);
        }
    }

    end = clock();
    int units = end -start;
    std::cout << "Time for generating Buttons:" << (double)units / ((double)CLOCKS_PER_SEC) << "sec" << std::endl;

    show_all_children();
}

NButton::~NButton()
{
}

void NButton::on_button_quit()
{
    hide();
}

void NButton::on_button_numbered()
{
    std::cout << "Hello again a button was pressed" << std::endl;
}
