#include "Squares.h"
#include <cairomm/context.h>
#include <iostream>
#include <stdlib.h>
#include <gdk/gdkkeysyms.h>
#include <time.h>

Squares::Squares()
{
}

Squares::~Squares()
{
}

#define NUM 600.0f
#define W 15
#define N 60
#define O 10
#define TIMES 25

bool Squares::on_expose_event(GdkEventExpose* event)
{
    // Get Window
    Glib::RefPtr<Gdk::Window> window = get_window();
    if(window)
    {
        // Create Cairo Context
        Cairo::RefPtr<Cairo::Context> cr = window->create_cairo_context();
        // Clean the canvas
        cr->set_source_rgb(1, 1, 1);
        cr->rectangle(0,0,NUM,NUM);
        cr->fill();
    }

    return true;
}

bool Squares::on_key_press(GdkEventKey* event)
{
    Glib::RefPtr<Gdk::Window> window = get_window();
    Cairo::RefPtr<Cairo::Context> cr = window->create_cairo_context();


    cr->set_source_rgb(1, 1, 1);
    cr->rectangle(0,0,NUM,NUM);
    cr->fill();

    if(event->keyval == GDK_r)
    {

        //initialize Timer
        std::cout << "Redraw!" << std::endl;
        clock_t start, end;
        start = clock();
        

        for (int i = 0; i < TIMES; i++)
        {
            cr->set_source_rgba(1,0,0,0.02f);
            for (int x = 0; x < N; x++)
            {
                for(int y = 0; y < N; y++)
                {            
                    cr->rectangle(x * O, y * O, W, W);
                    cr->fill();
                }
            }
        }
        
        // print timer
        end = clock();
        clock_t units = end - start;
        std::cout << "Rendertime:" << (double)units / ((double)CLOCKS_PER_SEC) << "sec" << std::endl;
    }
    else if ( event->keyval == GDK_Escape)
        gtk_main_quit();

    return true;
}
