#include "Text.h"
#include <cairomm/context.h>
#include <iostream>
#include <stdlib.h>
#include <gdk/gdkkeysyms.h>
#include <time.h>

Text::Text()
{
}

Text::~Text()
{
}

#define NUM 600.0f

bool Text::on_expose_event(GdkEventExpose* event)
{
    // Get Window
    Glib::RefPtr<Gdk::Window> window = get_window();
    if(window)
    {
        // Create Cairo Context
        Cairo::RefPtr<Cairo::Context> cr = window->create_cairo_context();
        // Clean the canvas
        cr->set_source_rgb(1, 1, 1);
        cr->rectangle(0,0,NUM,NUM);
        cr->fill();
    }

    return true;
}

bool Text::on_key_press(GdkEventKey* event)
{
    Glib::RefPtr<Gdk::Window> window = get_window();
    Cairo::RefPtr<Cairo::Context> cr = window->create_cairo_context();

    cr->set_source_rgb(1, 1, 1);
    cr->rectangle(0,0,NUM,NUM);
    cr->fill();

    if(event->keyval == GDK_r)
    {

        Pango::FontDescription fontdesc("Sans 12");

        Glib::RefPtr<Pango::Layout> layout = create_pango_layout("");
        layout->set_font_description(fontdesc);

        layout->set_markup("hello world");

        //initialize Timer
        std::cout << "Redraw!" << std::endl;
        double time, start, end;
        start = clock();

        for (int i = 0; i < 10000; i++)
        {            
	        gint x = g_random_int_range (0, NUM - 92);
	        gint y = g_random_int_range (0, NUM - 16);

            get_window()->draw_layout(Gdk::GC::create(get_window()), x, y, layout);
        }
        
        // print timer
        end = clock();
        double units = end -start;
        std::cout << "Rendertime:" << (double)units / ((double)CLOCKS_PER_SEC) << "sec" << std::endl;
    }
    else if ( event->keyval == GDK_Escape)
        gtk_main_quit();

    return true;
}
